// GameDoc.cpp : implementation of the CGameDoc class
//

#include "stdafx.h"
#include "Game.h"
#include <math.h>
#include "DiscussDlg.h"

#include "GameDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGameDoc

IMPLEMENT_DYNCREATE(CGameDoc, CDocument)

BEGIN_MESSAGE_MAP(CGameDoc, CDocument)
	//{{AFX_MSG_MAP(CGameDoc)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGameDoc construction/destruction

CGameDoc::CGameDoc()
{
	// TODO: add one-time construction code here
	turn=1.5702; //RADIALEN gedraaid
	eyex=0;
	eyey=2;
	eyez=20;
	refx=0;
	refy=2;
	refz=24;
	p1score=p2score=0;
	light=TRUE;
	textures=TRUE;
	boom=false ;//bullet vd speler zelf
	verwerking=false;
	hit = 0;
	bullet[0].x=0;
	bullet[0].y=0;
	bullet[0].z=0;
	bullet[0].angle=0;
	for(int i=0;i<4;bullet[i++].shot=false);
	//een default enemy instellen (~target practise)
	Enemy[0].hit=0;
	Enemy[0].shooting=0;
	Enemy[0].died=0;
	Enemy[0].number=1;
	Enemy[0].score=0;
	Enemy[0].x=-2.0;
	Enemy[0].y=3;
	Enemy[0].z=22.1;
	Enemy[0].lookx=-2.0;
	Enemy[0].looky=3;
	Enemy[0].lookz=18.1;
	//Players instellen (er is er minstens altijd 1)
	players=2; //2 zodat statische vijand ook te zien is.
}

CGameDoc::~CGameDoc()
{
}

BOOL CGameDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

		// Zet de beginsituatie goed

	InGame = FALSE;
	Player2Name = "";

		// maak de verwijzingen naar de socket class

	m_sConnectSocket.SetParent(this);
	m_sListenSocket.SetParent(this);


	CDiscussDlg Dialog;				// Declareer een dialog box

	Dialog.m_iPort = 4000;			// Maak de volgende variabelen reeds op voordat
	Dialog.m_strName = "loopback";	// de dialog box tevoorschijn komt.

	if(Dialog.DoModal() == IDOK)	// Laat ze verschijnen tijdens het opstarten
	{								// als de OK button wordt ingedrukt volgt de rest...
		if(Dialog.m_iType == 0)		// Als de client versie van het programma wordt gekozen
		{							// voer dan volgende code uit
			m_sConnectSocket.Create();	// maak een connectie met de server
			m_sConnectSocket.Connect(Dialog.m_strName, Dialog.m_iPort);
		}
		if(Dialog.m_iType == 1)		// als er voor de server versie van het programma
		{							// wordt gekozen, voer dan volgende code uit
			m_sListenSocket.Create(Dialog.m_iPort);
			m_sListenSocket.Listen();	// luister of er clients proberen in te loggen
		}
		if(Dialog.m_iType == 2)
			InGame = true;
	}

	Player1Name = Dialog.m_strPlayer;
	namesend=false;
	
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGameDoc serialization

void CGameDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGameDoc diagnostics

#ifdef _DEBUG
void CGameDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGameDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGameDoc commands

void CGameDoc::RenderScene()
{
	SetCursor(NULL);	//AfxGetApp()->LoadCursor(IDC_NOCUR));

	GLfloat NormalSurface[] = { 2.3f, 2.3f, 2.3f, 1.0f};
	GLfloat RedSurface[]    = { 1.0f, 0.0f, 0.0f, 1.0f};
	GLfloat GreenSurface[]  = { 0.0f, 1.0f, 0.0f, 1.0f};
	GLfloat BlueSurface[]   = { 0.0f, 0.0f, 1.0f, 1.0f};	
	GLfloat PurpleSurface[] = { 2.3f, 0.0f, 2.3f, 1.0f};
	GLfloat CyanSurface[]   = { 0.0f, 1.6f, 1.4f, 1.0f};
	GLfloat YellowSurface[] = { 2.0f, 2.0f, 0.0f, 1.0f};
	GLfloat GraySurface[]   = { 0.6f, 0.6f, 0.6f, 1.0f};

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	//light1
	GLfloat LightAmbient[] =  { 0.5f, 1.0f, 0.5f, 1.0f};
	GLfloat LightDiffuse[] =  { 0.5f, 0.5f, 1.0f, 1.0f};
	GLfloat LightSpecular[] = { 0.5f, 0.5f, 0.8f, 1.0f};
	GLfloat LightPosition[] = {12.0f, 2.5f,32.0f, 1.0f}; 
	GLfloat LightSpotPos[] =  { 1.0f, 0.0f, 1.0f};
	GLfloat LightSpotExp = 2.0f;
	GLfloat LightSpotCutoff = 32.0f;
	//light2
	GLfloat Light2Ambient[] =  { 0.2f, 1.5f, 0.0f, 1.0f};
	GLfloat Light2Diffuse[] =  { 0.1f, 1.0f, 0.0f, 1.0f};
	GLfloat Light2Specular[] = { 0.0f, 0.4f, 0.8f, 1.0f};
	GLfloat Light2Position[] = { 0.0f, 5.0f,20.0f, 1.0f}; 
	GLfloat Light2SpotPos[] =  { 0.0f, -1.0f, 0.0f};
	GLfloat Light2SpotExp = 2.0f;
	GLfloat Light2SpotCutoff = 45.0f;
	//light3
	GLfloat Light3Ambient[] =  { 1.5f, 0.1f, 1.5f, 1.0f};
	GLfloat Light3Diffuse[] =  { 1.5f, 0.1f, 1.5f, 1.0f};
	GLfloat Light3Specular[] = { 0.0f, 0.3f, 1.0f, 1.0f};
	GLfloat Light3Position[] = {-12.0f, 2.5f, 8.0f, 1.0f}; 
	GLfloat Light3SpotPos[] =  {-1.0f, 0.0f,-1.0f};
	GLfloat Light3SpotExp = 2.0f;
	GLfloat Light3SpotCutoff = 32.0f;

	//bullet = plasma
	GLfloat Light4Ambient[] =  { 1.0f, 0.0f, 1.5f, 1.0f};
	GLfloat Light4Diffuse[] =  { 1.0f, 0.1f, 1.5f, 1.0f};
	GLfloat Light4Specular[] = { 1.0f, 0.8f, 1.0f, 1.0f};
	GLfloat Light4Position[] = {(float)bullet[0].x,(float)bullet[0].y+2.0f,(float)bullet[0].z, 1.0f}; 
	GLfloat Light4SpotPos[] =  {(float)cos(turn), -1.0f,(float)sin(turn)};
	GLfloat Light4SpotExp = 5.0f;
	GLfloat Light4SpotCutoff = 80.0f;

	
	glPushMatrix();		
		//zorg dat het een beetje licht is in de wereld.
		//Dit door alle materialen al een 'ambient' uitstraling te geven.
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, NormalSurface);

		//camera aanpassen (prachtige functie btw - haalt veel werk uit handen.
		//Anders zouden we alle projectiematrixen moeten aanpassen en de Orthofunctie
		//moeten aanroepen.)
		gluLookAt(eyex, eyey, eyez, //eye-pos
				  refx, refy, refz, //direction to look
				  0.0, 1.0, 0.0);   //up-vector (always the same)

		if(light){
			//light1
			glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
			glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
			glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpecular);
			glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
			glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, LightSpotPos);
			glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, LightSpotExp);
			glLightf(GL_LIGHT0, GL_SPOT_CUTOFF,LightSpotCutoff);
			//light2
			glLightfv(GL_LIGHT1, GL_AMBIENT, Light2Ambient);
			glLightfv(GL_LIGHT1, GL_DIFFUSE, Light2Diffuse);
			glLightfv(GL_LIGHT1, GL_SPECULAR, Light2Specular);
			glLightfv(GL_LIGHT1, GL_POSITION, Light2Position);
			glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, Light2SpotPos);
			glLightf(GL_LIGHT1, GL_SPOT_EXPONENT, Light2SpotExp);
			glLightf(GL_LIGHT1, GL_SPOT_CUTOFF,Light2SpotCutoff);
			//light3
			glLightfv(GL_LIGHT2, GL_AMBIENT, Light3Ambient);
			glLightfv(GL_LIGHT2, GL_DIFFUSE, Light3Diffuse);
			glLightfv(GL_LIGHT2, GL_SPECULAR, Light3Specular);
			glLightfv(GL_LIGHT2, GL_POSITION, Light3Position);
			glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, Light3SpotPos);
			glLightf(GL_LIGHT2, GL_SPOT_EXPONENT, Light3SpotExp);
			glLightf(GL_LIGHT2, GL_SPOT_CUTOFF,Light3SpotCutoff);

			//plasma bullet
			glLightfv(GL_LIGHT3, GL_AMBIENT, Light4Ambient);
			glLightfv(GL_LIGHT3, GL_DIFFUSE, Light4Diffuse);
			glLightfv(GL_LIGHT3, GL_SPECULAR, Light4Specular);
			glLightfv(GL_LIGHT3, GL_POSITION, Light4Position);
			glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, Light4SpotPos);
			glLightf(GL_LIGHT3, GL_SPOT_EXPONENT, Light4SpotExp);
			glLightf(GL_LIGHT3, GL_SPOT_CUTOFF,Light4SpotCutoff);
			
			//Lichtjes aanzetten (max 8 in OGL hardware)
			glEnable(GL_LIGHT0);
			glEnable(GL_LIGHT1);
			glEnable(GL_LIGHT2);
			glEnable(GL_LIGHT3);			
		};
		//grond
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[0]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GraySurface);
		glBegin(GL_POLYGON);
			glNormal3d(0.0, 1.0,  0.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -20.0, 0.0,  0.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  20.0, 0.0,  0.0);
			glTexCoord2f( 3.0, 6.0);glVertex3d(  20.0, 0.0, 40.0);
			glTexCoord2f(-3.0, 6.0);glVertex3d( -20.0, 0.0, 40.0);
		glEnd();
		
		//muur aan rechterkant
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[1]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, RedSurface);
		glBegin(GL_POLYGON);
			glNormal3d( -1.0, 0.0, 0.0);
			glTexCoord2f(0.0, 0.0);glVertex3d( 20.0,  0.0,  0.0);
			glTexCoord2f(6.0, 0.0);glVertex3d( 20.0,  0.0, 40.0);
			glTexCoord2f(6.0, 2.0);glVertex3d( 20.0,  5.0, 40.0);
			glTexCoord2f(0.0, 2.0);glVertex3d( 20.0,  5.0,  0.0);
		glEnd();

		//gele muur aan linkerkant
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[2]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, YellowSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   1.0,  0.0,  0.0);
			glTexCoord2f( 0.0, 0.0);glVertex3d( -20.0,  0.0,  0.0);
			glTexCoord2f( 6.0, 0.0);glVertex3d( -20.0,  0.0, 40.0);
			glTexCoord2f( 6.0, 2.0);glVertex3d( -20.0,  5.0, 40.0);
			glTexCoord2f( 0.0, 2.0);glVertex3d( -20.0,  5.0,  0.0);
		glEnd();

		//groene muur vanvoor
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[3]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GreenSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0,  0.0,  1.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -20.0,  0.0,  0.0);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -20.0,  5.0,  0.0);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  20.0,  5.0,  0.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  20.0,  0.0,  0.0);
		glEnd();

		//blauwe muur vanachter
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[1]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BlueSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0,  0.0, -1.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -20.0,  0.0, 40.0);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -20.0,  5.0, 40.0);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  20.0,  5.0, 40.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  20.0,  0.0, 40.0);
		glEnd();


		//1ste obstakel (muur)
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, YellowSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0, 0.0,  -1.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -15.0, 0.0, 10.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  15.0, 0.0, 10.0);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  15.0, 5.0, 10.0);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -15.0, 5.0, 10.0);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, YellowSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   1.0, 0.0,  0.0);
			glTexCoord2f( 0.0, 0.0);glVertex3d(  15.0, 0.0, 10.0);
			glTexCoord2f( 1.0, 0.0);glVertex3d(  15.0, 0.0, 12.5);
			glTexCoord2f( 1.0, 2.0);glVertex3d(  15.0, 5.0, 12.5);
			glTexCoord2f( 0.0, 2.0);glVertex3d(  15.0, 5.0, 10.0);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, YellowSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0, 0.0,  1.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  15.0, 0.0, 12.5);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -15.0, 0.0, 12.5);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -15.0, 5.0, 12.5);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  15.0, 5.0, 12.5);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, YellowSurface);
		glBegin(GL_POLYGON);
			glNormal3d(  -1.0, 0.0, 0.0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( -15.0, 0.0, 12.5);
			glTexCoord2f( 0.0, 0.0);glVertex3d( -15.0, 0.0, 10.0);
			glTexCoord2f( 0.0, 2.0);glVertex3d( -15.0, 5.0, 10.0);
			glTexCoord2f( 1.0, 2.0);glVertex3d( -15.0, 5.0, 12.5);
		glEnd();

		//2de obstakel (muur)
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, CyanSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0, 0.0,  -1.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -15.0, 0.0, 27.5);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  15.0, 0.0, 27.5);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  15.0, 5.0, 27.5);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -15.0, 5.0, 27.5);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, CyanSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   1.0, 0.0,  0.0);
			glTexCoord2f( 0.0, 0.0);glVertex3d(  15.0, 0.0, 27.5);
			glTexCoord2f( 1.0, 0.0);glVertex3d(  15.0, 0.0, 30.0);
			glTexCoord2f( 1.0, 2.0);glVertex3d(  15.0, 5.0, 30.0);
			glTexCoord2f( 0.0, 2.0);glVertex3d(  15.0, 5.0, 27.5);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, CyanSurface);
		glBegin(GL_POLYGON);
			glNormal3d(   0.0, 0.0,  1.0);
			glTexCoord2f( 3.0, 0.0);glVertex3d(  15.0, 0.0, 30.0);
			glTexCoord2f(-3.0, 0.0);glVertex3d( -15.0, 0.0, 30.0);
			glTexCoord2f(-3.0, 2.0);glVertex3d( -15.0, 5.0, 30.0);
			glTexCoord2f( 3.0, 2.0);glVertex3d(  15.0, 5.0, 30.0);
		glEnd();

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[5]);   		
		else
			glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, CyanSurface);
		glBegin(GL_POLYGON);
			glNormal3d(  -1.0, 0.0, 0.0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( -15.0, 0.0, 30.0);
			glTexCoord2f( 0.0, 0.0);glVertex3d( -15.0, 0.0, 27.5);
			glTexCoord2f( 0.0, 2.0);glVertex3d( -15.0, 5.0, 27.5);
			glTexCoord2f( 1.0, 2.0);glVertex3d( -15.0, 5.0, 30.0);
		glEnd();

			// Deze tijdelijke hoek wordt bijgevoegd om geen statisch vlak te krijgen
			// tijdens de deathmatch. Met deze aanvulling kan ten alle tijde de tegen-
			// speler langs de voorkant gezien worden door jezelf.
		double tmp_angle = atan2(double(refz-eyez),double(refx-eyex));
		tmp_angle+=1.57;
		//vijanden op het scherm zetten.
		for(int i=1;i<players;i++) {
			if(Enemy[i-1].shooting)
				glBindTexture(GL_TEXTURE_2D, myTexs[6]);
			else
				glBindTexture(GL_TEXTURE_2D, myTexs[7]);
			glBegin(GL_POLYGON);
				glTexCoord2f( 0.0, 0.0);glVertex3d( Enemy[i-1].x,   0, Enemy[i-1].z);
				glTexCoord2f( 0.0, 1.0);glVertex3d( Enemy[i-1].x,   3, Enemy[i-1].z);
				glTexCoord2f( 1.0, 1.0);glVertex3d( Enemy[i-1].x+1.5*cos(tmp_angle), 3, Enemy[i-1].z+1.5*sin(tmp_angle));
				glTexCoord2f( 1.0, 0.0);glVertex3d( Enemy[i-1].x+1.5*cos(tmp_angle), 0, Enemy[i-1].z+1.5*sin(tmp_angle));
			glEnd();
		};
		
		glPushMatrix(); //projectiematrix even op stack zetten, omdat we glTranslate gebruiken.
			//boll in het midden
			glTranslated(0.0, 0.0, 20.0);
			GLUquadricObj* mysphere = gluNewQuadric();
			gluSphere( mysphere, 1.6, 20,20);
			gluDeleteQuadric(mysphere);
		glPopMatrix();
	
		for(i=0;i<4;i++)
			if(bullet[i].shot) {
				glPushMatrix();
				glTranslated(bullet[i].x, bullet[i].y, bullet[i].z);
				bullet[i].x+=3*cos(bullet[i].angle); //move bullet further;
				bullet[i].z+=3*sin(bullet[i].angle); // ..
				if( (bullet[i].x>22.0) || (bullet[i].x<-22.0) 
					|| (bullet[i].z<-1.0) || (bullet[i].z>42.0) )
					bullet[i].shot=false; //bullet out of room : no more bullet
				else {
					//draw bullet at position.
					GLUquadricObj* mysphere = gluNewQuadric();
					gluSphere( mysphere, 0.1, 8,8);
					gluDeleteQuadric(mysphere);
				}
				glPopMatrix();
				// kijken of een kogel speler raakt
				// eerst eigen speler ?
				if( (bullet[i].x<eyex+1)&&(bullet[i].x>eyex-1)&&
					(bullet[i].z<eyez+1)&&(bullet[i].z>eyez-1)){
					bullet[i].shot=false;
					hit=1;
				}
				else hit=0;
			}
			else {
				glDisable(GL_LIGHT3);
				bullet[i].shot=false;
			};

		glPushMatrix();
			glBindTexture(GL_TEXTURE_2D, myTexs[4]);
			glTranslated(0,20.0,0);
			glRotated(1.5702, 10,0,0);
			GLUquadricObj* mycyl = gluNewQuadric();
			gluQuadricTexture(mycyl,GL_TRUE);
			gluSphere(mycyl, 60, 50, 50);
			gluDeleteQuadric(mycyl);
		glPopMatrix();
	
		//visier tekenen
		glBegin(GL_LINE_STRIP);
			glColor3f(5,5,5);
			glVertex3d(refx,refy+0.2,refz);
			glVertex3d(refx,refy-0.2,refz);
		glEnd();
		glBegin(GL_LINE_STRIP);
			glColor3f(5,5,5);
			glVertex3d(refx+cos(turn+1.5702)/5,refy,refz+sin(turn+1.5702)/5);
			glVertex3d(refx+cos(turn-1.5702)/5,refy,refz+sin(turn-1.5702)/5);
		glEnd();
		
		//geweer tekenen
		//Normaal een 8-vlak, maar door de positie vd speler, kunnen maar 4 vlakken max.
		//gezien worden dus worden er ook maar 4 getekend.
		double helpx,helpy;
		helpx=helpy=0;
		glPushMatrix();	//omdat we object-transformaties en translaties voor het geweer gaan					 
						//(0.7854 = 45)
		glTranslated(eyex,eyey-2,eyez); 
		glRotated(-(turn-1.5702)*180/3.141592,0,1,0);

		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[8]);
		else
			glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, PurpleSurface);
		glBegin(GL_QUADS);
			//1ste vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( -0.1, 1, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( -0.1, 1, 2.0);
			glTexCoord2f( 1.0, 1.0);glVertex3d(  0.1, 1, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d(  0.1, 1, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[9]);
		glBegin(GL_QUADS);
			helpx=cos(1.5702+0.7854)/5-0.1;
			helpy=sin(1.5702+0.7854)/5+1;
			glTexCoord2f( 0.0, 0.0);glVertex3d( -0.1, 0, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( -0.1, 0, 2);
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[8]);
		glBegin(GL_QUADS);
			//3de vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpy+=0.2;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[9]);
		glBegin(GL_QUADS);
			//4de vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpx+=cos(0.7854)/5;
			helpy+=sin(0.7854)/5;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[8]);
		glBegin(GL_QUADS);
			//5de vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpx+=0.2;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[9]);
		glBegin(GL_QUADS);
			//6de vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpx-=cos(0.7854)/5;
			helpy-=sin(0.7854)/5;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[8]);
		glBegin(GL_QUADS);
			//7de vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpy-=0.2;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		if(textures)
			glBindTexture(GL_TEXTURE_2D, myTexs[9]);
		glBegin(GL_QUADS);
			//8ste vlak
			glTexCoord2f( 0.0, 0.0);glVertex3d( helpx, helpy, 0);
			glTexCoord2f( 1.0, 0.0);glVertex3d( helpx, helpy, 2.0);
			helpx=0.1;
			helpy=1;
			glTexCoord2f( 1.0, 1.0);glVertex3d( helpx, helpy, 2.0);
			glTexCoord2f( 0.0, 1.0);glVertex3d( helpx, helpy, 0);
		glEnd();
		glPopMatrix();	
		
	glPopMatrix();
	glFlush();

		// Hier volgt uiteindelijk de aanroep om de
		// huidige stand van de player door te sturen.
	OnSend();
}

void CGameDoc::OnAccept()
{
	m_sListenSocket.Accept(m_sConnectSocket);
		// als er een client inlogt
	InGame = true;
}

void CGameDoc::OnConnect()
{
		// connectie met andere is gemaakt
	InGame = true;
}

void CGameDoc::OnClose()
{
		// sluit de connectie op een ordelijke manier af.
	m_sConnectSocket.Close();
}

void CGameDoc::OnSend()
{
	int iLen;
	int iSent;

	CString strMessage;

/* 
  Even de filosofie achter het spel uitleggen.
  Ik bekijk het volgende vanuit 1 computer waar ik op speel.
  In mijn gedachten zal de andere computer altijd goed functioneren
  (ik server, andere client)

  *IK* ben de speler die in het spel rondloopt. De vijand
  ( Enemy[0], niet 1 ) is de speler die op de andere PC speelt

  Wat gezonden wordt naar de andere computer (OnSend) zijn de
  cordinaten waar IK mij bevindt.

  En wat ik aan cordinaten binnenkrijg (OnReceive), zijn de cor-
  dinaten van mijn vijand. ( Enemy[0] )

  Dus... je moet dus je eigen cordinaten
  doorsturen. (eyex, eyey, eyez, refx, refy, refz)

  En in OnReceive krijg je de cordinaten binnen waar de andere
  speler (op de andere PC) zich bevindt. Dus die moet je in Enemy[0] 
  steken. (er zijn dus ten alle tijde 2 spelers : jij en de vijand)

  Als je dit bekijkt voor de andere computer, dan krijgt die mijn
  positie binnen en stuurt die zijn eigen positie naar buiten.
  Voor de andere computer ben IK de vijand ( Enemy[0] ). Dus de waarde
  die hij binnenkrijgt, slaat hij op in de Enemy-STRUCT.
  
  Even uitleggen wat er allemaal gebeurd.

  Alle input van de speler wordt opgevangen en de wereld wordt 
  opnieuw getekend.

  Nu moet na het tekenen van de wereld de cordinaten en de
  status van 'IK' doorgestuurd worden naar de andere computer.
  Dus waar ik sta, waar ik naar kijk, of ik geschoten heb of niet,
  welke speler ik ben enz. Dat is alles wat dus verstuurt moet worden.

  Dan moet je zorgen dat als er gegevens binnenkomen van de andere
  computer, dat deze goed verwerkt worden :

  1) Eerst steek je de cordinaten die je binnenkrijgt in de juiste
  enemy (nu spelen we maar met 2, dus de enemy is altijd nr 0).
  
  2) Als er in die string staat dat de speler geschoten heeft (waarde
  '1' op de 2de plaats in de string), dan moet je zijn cordinaten
  waar deze persoon staat in een BULLET struct zetten. (hij schiet
  een kogel af vanaf de plaats waar hij staat) en deze BULLET.shot 
  op 'true' zetten. Zodat de kogel geanimeerd wordt. 
  (deze animatie wordt in RenderScene gedaan.

  Je eigen kogel gebruikt bullet[0], dus als de vijand geschoten heeft,
  gebruik je de waarde in bullet[1]. De waarden voor bullet[0] worden
  in LButtonDown gezet. (moest je nieuwsgierig zijn... )
  Enige moeilijkheid hierbij is dat je de hoek moet bereken waar
  de speler naar kijkt. Deze hoek is in radialen (belangrijk!!).
  Kun je gemakkelijk vinden door formuleke toe te passen.
  tangens(hoek) = (lookz - z) / (lookx - x)
  En dan inverse nemen.

  Ook moet in de Enemy-struct 'shooting' op true komen te staan. 
  Of op 1 als het een integer is.

  3) als je gegevens krijgt dat de vijand geraakt is, moet je hiervoor
     zorgen dat in Enemy 'hit' op true komt te staan.

*/

		// Als de namen van de spelers nog niet zijn doorgestuurd aan elkaar doe dat
		// dan nu
	if(!namesend)
	{
		OnSendPlayer();
		namesend=true;		// als ze zijn doorgestuurd..., zorgt ervoor dat het maar 1 keer gebeurd
	}
	else 
	{

			// shooting omzetten in leesbare integer, want 'boom' 
			// kan niet zomaar doorgestuurd worden, 
			// want dit is een boolean en geen integer.
	
		strMessage.Format("%d;%d;%d;%f;%f;%f;%f;%f;%f!",
							0,			// nummer (0de vijand)
							boom,		// geschoten?
							hit,		// geraakt?
							eyex,		// positie + kijkrichting 
							eyey,
							eyez,
							refx,
							refy,
							refz);

		if(boom==TRUE) boom=FALSE;

			// is er een message die doorgestuurd moet worden?
		if(strMessage != "")
		{
			iLen = strMessage.GetLength();
				// Stuur de message door
			iSent = m_sConnectSocket.Send(LPCTSTR(strMessage), iLen);
		}
	}
}

void CGameDoc::OnReceive()
{
		// als er nog geen verwerking van ontvangen data aan de gang is mag de routine
		// gevolgd worden. Deze check dient eigenlijk als beveiliging om geen overstelping
		// van inkomende data te krijgen die de boel flink om zeep kunnen helpen.
		// Mits RenderScene() via timers werkt en de beelden elkaar flink opvolgen, 
		// wordt de OnSend() functie veelvuldig aangeroepen.
	if(!verwerking)
	{
			// zolang er in de lus gezeten wordt mag er geen nieuwe data worden
			// toegevoegd aan de buffer
		verwerking = true;
	
		char *pBuf = new char[1025];
		int iBufSize = 1024;
		int iRcvd;
		int teller;

		teller = 0;
	
		CString temp;
		CString strRecvd;
		CString strTijdelijk;
		CString Tijdelijk;

			// ontvangen van het bericht
		iRcvd = m_sConnectSocket.Receive(pBuf, iBufSize);
			// is er iets aangekomen?
		if (iRcvd == SOCKET_ERROR)
		{
		}
		else
		{
				// rond het einde af
			pBuf[iRcvd] = NULL;
				// kopieer het bericht naar een string.
			strRecvd = pBuf;
		}

//	AfxMessageBox(strRecvd);   // testen of er data doorgestuurd kan worden.

		// als de message niet leeg is ga dan door.
		if(strRecvd !="")
		{
			temp=strRecvd[0];
			if(temp == "(")		// hier wordt gekeken of er namen worden doorgestuurd
			{
				Player2Name = strRecvd;
				Player2Name.Delete(0,1);	// eerste teken weghalen want is een (
				Tijdelijk.Format("%s:%d | %s:%d",Player1Name,p1score,
												Player2Name,p2score);
//				CStatusBar m_wndStatusBar;
//				m_wndStatusBar.SetPaneText(1,Tijdelijk,true);
				
//				CMainFrame* m_wndStatusBar;
//				m_wndStatusBar.SetPaneText(1,Tijdelijk,true);

//				CStatusBar *pbar; = CMainFrame.m_wndStatusBar;
//				pbar->SetPaneText(1,Tijdelijk,true);

			}
			else			
			if(InGame)
			{				// zolang einde message niet bereikt is, ...
				for(int teller2 = 0; teller2 < 9; teller2++)
				{
					strTijdelijk = ""; //na elke ';' string leegmaken
						//nu nieuwe variabele kopieren in strTijdelijk.
					teller++;
					temp=strRecvd[teller];
					while( (temp != ";") && (temp != "!"))
					{
						strTijdelijk += strRecvd[teller];
						teller++;
						temp=strRecvd[teller];
					}

						// respectievelijke variabelen invullen
					if(teller2 == 0)
						Enemy[0].number = atoi(LPCTSTR(strTijdelijk));
					if(teller2 == 1)
						Enemy[0].shooting = atoi(LPCTSTR(strTijdelijk));
					if(teller2 == 2)
						Enemy[0].hit = atoi(LPCTSTR(strTijdelijk));
					if(teller2 == 3)
						Enemy[0].x = atof(LPCTSTR(strTijdelijk));
					if(teller2 == 4)
						Enemy[0].y = atof(LPCTSTR(strTijdelijk));
					if(teller2 == 5)
						Enemy[0].z = atof(LPCTSTR(strTijdelijk));
					if(teller2 == 6)
						Enemy[0].lookx = atof(LPCTSTR(strTijdelijk));
					if(teller2 == 7)
						Enemy[0].looky = atof(LPCTSTR(strTijdelijk));
					if(teller2 == 8)
						Enemy[0].lookz = atof(LPCTSTR(strTijdelijk));
				}
			}
		}
		// als de vijand schiet dan is het altijd leuk dat er een kogel te zien valt.
		// Dat gebeurt in renderscene maar de berekening van waar de kogel begint te
		// schieten en in welke richting hij gaat wordt hier uitgerekend.
	if(Enemy[0].shooting == 1)
	{
		bullet[1].shot = true;
		bullet[1].x = Enemy[0].x;
		bullet[1].y = Enemy[0].y;
		bullet[1].z = Enemy[0].z;
		bullet[1].angle = atan2(double(Enemy[0].lookz-Enemy[0].z),double(Enemy[0].lookx-Enemy[0].x));
		Enemy[0].shooting=0;
	}

		// scores aanpassen
	if(Enemy[0].hit==1)
	{
		p1score++;
		Tijdelijk.Format("%s:%d | %s:%d",Player1Name,p1score,
											Player2Name,p2score);
//		AfxMessageBox(Tijdelijk);
	}
	if(hit==1)
	{
		p2score++;
		Tijdelijk.Format("%s:%d | %s:%d",Player1Name,p1score,
											Player2Name,p2score);
//		AfxMessageBox(Tijdelijk);
	}


		// functie terug vrij zetten om nieuwe data te laten inkomen die ontleed
		// kan worden en omgezet naar de respectievelijke variabelen.
	verwerking = false;
	}
}

void CGameDoc::OnAppExit() 
{
	// TODO: Add your command handler code here
	OnClose();
}


void CGameDoc::OnSendPlayer()
{
	int iLen;
	int iSent;

	CString strMessage;

	strMessage.Format("(%s",Player1Name);
	if(strMessage != "")
	{
		iLen = strMessage.GetLength();
			// Stuur de message door
		iSent = m_sConnectSocket.Send(LPCTSTR(strMessage), iLen);
	}
}
