// GameDoc.h : interface of the CGameDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEDOC_H__01580F8A_A31C_11D3_B71A_080000346601__INCLUDED_)
#define AFX_GAMEDOC_H__01580F8A_A31C_11D3_B71A_080000346601__INCLUDED_

#include "MySocket.h"	// Added by ClassView
#include "MainFrm.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//structure for enemies. 
struct ENEMY {
	/*as booleans*/
	int died;
	int shooting;
	int hit;
    /*-----------*/
	int number;
	int score;
	GLdouble x;
	GLdouble y;
	GLdouble z;
	GLdouble lookx;
	GLdouble looky;
	GLdouble lookz;
	};

struct BULLET {
	BOOL shot;
	GLdouble angle;
	GLdouble x;
	GLdouble y;
	GLdouble z;
	};

class CGameDoc : public CDocument
{
protected: // create from serialization only
	CGameDoc();
	DECLARE_DYNCREATE(CGameDoc)

// Attributes
public:
 	GLuint myTexs[10];
	GLubyte txGround[256*256*3];
	GLubyte txWall1[256*256*3];
	GLubyte txWall2[256*256*3];
	GLubyte txWall3[256*256*3];
	GLubyte txWood[256*256*3];
	GLubyte txSprite1[32*64*3];
	GLubyte txSprite2[32*64*3];
	GLubyte txSky[256*256*3];
	GLubyte bmGun1[256*256*3];
	GLubyte bmGun2[256*256*3];
	GLdouble refx;
	GLdouble refy;
	GLdouble refz;
	GLdouble eyey;
	GLdouble eyez;
	GLdouble eyex;
	BOOL boom;
	void RenderScene();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGameDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL
	
private:
	CMySocket m_sConnectSocket;
	CMySocket m_sListenSocket;

// Implementation
public:
	BOOL namesend;
	BOOL verwerking;
	CString Player1Name;
	CString Player2Name;
	void OnSendPlayer();
	BOOL InGame;
	int Test;
	int hit;
	int p1score,p2score;
	void OnReceive();
	void OnSend();
	void OnClose();
	void OnConnect();
	void OnAccept();
	int players; //indicate how many players there are. ( max 4 in _total_ )
	ENEMY Enemy[3];
	BULLET bullet[4]; //3 voor de Enemies en 1 voor de speler zelf;[0] is altijd speler zelf
	UINT myTimer;
	HWND ditwindow;
	BOOL bulletshot;
	BOOL textures;
	BOOL light;
	double turn;
	virtual ~CGameDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGameDoc)
	afx_msg void OnAppExit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GAMEDOC_H__01580F8A_A31C_11D3_B71A_080000346601__INCLUDED_)
