// GameView.cpp : implementation of the CGameView class
//

#include "stdafx.h"
#include "Game.h"
#include "DiscussDlg.h"
#include "GameDoc.h"
#include "GameView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGameView

IMPLEMENT_DYNCREATE(CGameView, CView)

BEGIN_MESSAGE_MAP(CGameView, CView)
	//{{AFX_MSG_MAP(CGameView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_UPDATE_COMMAND_UI(ID_SMOOTH, OnUpdateSmooth)
	ON_COMMAND(ID_FILTER, OnFilter)
	ON_UPDATE_COMMAND_UI(ID_FILTER, OnUpdateFilter)
	ON_UPDATE_COMMAND_UI(ID_LIGHT, OnUpdateLight)
	ON_COMMAND(ID_LIGHT, OnLight)
	ON_COMMAND(ID_TEXTURES, OnTextures)
	ON_UPDATE_COMMAND_UI(ID_TEXTURES, OnUpdateTextures)
	ON_WM_TIMER()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGameView construction/destruction

CGameView::CGameView()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;
	viewangle=0; //radialen up/down kijken (hoek)
	looper=0;
	mypos=(25,15);
	mxpos=(25,15);
	smooth=TRUE;
	filter=TRUE;
	//initialise the objects
	//grenzen vd object 2 groter nemen. Dit moet doordat de field of view op 45 staat en
	//we zo nog een deel van de binnenkant zouden kunnen zien.
	nr_of_objects=2;
	Objects[0].what = RECTANG;
	Objects[0].points[0].x=-16;
	Objects[0].points[0].y=8;
	Objects[0].points[1].x=16;
	Objects[0].points[1].y=8;
	Objects[0].points[2].x=16;
	Objects[0].points[2].y=15;
	Objects[0].points[3].x=-16;
	Objects[0].points[3].y=15;

	Objects[1].what = RECTANG;
	Objects[1].points[0].x=-16;
	Objects[1].points[0].y=25;
	Objects[1].points[1].x=16;
	Objects[1].points[1].y=25;
	Objects[1].points[2].x=16;
	Objects[1].points[2].y=32;
	Objects[1].points[3].x=-16;
	Objects[1].points[3].y=32;
}

CGameView::~CGameView()
{
}

BOOL CGameView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS );

    screenHeight = ::GetSystemMetrics(SM_CYSCREEN); 
    screenWidth  = ::GetSystemMetrics(SM_CXSCREEN); 
    
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGameView drawing

void CGameView::OnDraw(CDC* pDC)
{
	CGameDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGameView diagnostics

#ifdef _DEBUG
void CGameView::AssertValid() const
{
	CView::AssertValid();
}

void CGameView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGameDoc* CGameView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGameDoc)));
	return (CGameDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGameView message handlers

BOOL CGameView::SetWindowPixelFormat(HDC myDC)
{
 	PIXELFORMATDESCRIPTOR pixelDesc= { 
    sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd 
    1,								// version number 
    PFD_DRAW_TO_WINDOW |			// support window 
	PFD_GENERIC_ACCELERATED	|		// support hardware accelleration
	PFD_SWAP_COPY |					// copy instead of swap. Less overhead
    PFD_SUPPORT_OPENGL |			// support OpenGL 
    PFD_DOUBLEBUFFER,				// double buffered 
    PFD_TYPE_RGBA,					// RGBA type 
    16,								// 24-bit color depth 
    0, 0, 0, 0, 0, 0,				// color bits ignored 
    0,								// no alpha buffer 
    0,								// shift bit ignored 
    0,								// no accumulation buffer 
    0, 0, 0, 0,						// accum bits ignored 
    16,								// 32-bit z-buffer     
    0,								// no stencil buffer 
    0,								// no auxiliary buffer 
    PFD_MAIN_PLANE,					// main layer 
    0,								// reserved 
    0, 0, 0							// layer masks ignored 
    }; 

	my_GLpixelindex = ChoosePixelFormat(myDC, &pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

BOOL CGameView::CreateGLRenderContext(HDC myDC)
{
	my_GLRendContext = wglCreateContext(myDC); 

	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}
	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

int CGameView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	HWND hWnd =	 GetSafeHwnd();
	HDC hDC = ::GetDC(hWnd);
	CGameDoc* pdoc = GetDocument();

	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;

/* Now we load in the different textures.. One for the ground and 3 for the walls.. */
	FILE *myfile;

	//handle naar ons window bijhouden.	
	pdoc->ditwindow=hWnd;

	//Grond texture laden
	myfile = fopen("GROUND.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txGround,1,256*256*3,myfile);
		fclose(myfile);
		};

	//Muur1 texture
	myfile = fopen("WALL1.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture2 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txWall1,1,256*256*3,myfile);
		fclose(myfile);
		};
	//Muur2 texture
	myfile = fopen("WALL2.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture3 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txWall2,1,256*256*3,myfile);
		fclose(myfile);
		};
	//Muur3 texture
	myfile = fopen("WALL3.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture4 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txWall3,1,256*256*3,myfile);
		fclose(myfile);
		};
	//lucht texture
	myfile = fopen("LUCHT.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture5 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txSky,1,256*256*3,myfile);
		fclose(myfile);
	};

	//Hout voor de houten muren
	myfile = fopen("CRATE.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture6 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txWood,1,256*256*3,myfile);
		fclose(myfile);
	};

	//Texture voor mannetje
	myfile = fopen("SPRITE.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture7 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txSprite1,1,32*64*3,myfile);
		fclose(myfile);
	};

	//Texture voor mannetje
	myfile = fopen("SPRITE2.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture7 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->txSprite2,1,32*64*3,myfile);
		fclose(myfile);
	};

	//texture 1 voor geweer laden
	myfile = fopen("GUN1.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the bitmap gun ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->bmGun1,1,256*256*3,myfile);
		fclose(myfile);
	};

	//texture 2 voor geweer laden
	myfile = fopen("GUN2.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the bitmap boom! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		int size = fread(pdoc->bmGun2,1,256*256*3,myfile);
		fclose(myfile);
	};

	glGenTextures(10,pdoc->myTexs);

	//grond definieren
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[0]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txGround);
	//wall1
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[1]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txWall1);
	//wall2
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[2]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txWall2);
	//wall3
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[3]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txWall3);
	//sky
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[4]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txSky);
	//Hout
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[5]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txWood);
	//mannetje1
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[6]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,128,128,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txSprite1);
	//mannetje2
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[7]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,32,64,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->txSprite2);
	//geweer texture1
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[8]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->bmGun1);
	//geweer texture2
	glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[9]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->bmGun2);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	
	CString HWorSW;
	HWorSW.Format("Vendor : ");
	HWorSW+=(LPCTSTR)glGetString(GL_VENDOR);
	if(HWorSW.Find("Microsoft")==-1)
		hardware=true;
	else
		hardware=false;
	HWorSW+="\nRenderer : ";
	HWorSW+=(LPCTSTR)glGetString(GL_RENDERER);
	HWorSW+="\nVersion: ";
	HWorSW+=(LPCTSTR)glGetString(GL_VERSION);
	HWorSW+="\nExtensions : ";
	HWorSW+=(LPCTSTR)glGetString(GL_EXTENSIONS);
	AfxMessageBox(HWorSW);
	
	SetTimer(1,50,NULL);
	return 0;
}

void CGameView::OnDestroy() 
{
	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}

	//delete the textures
	CGameDoc* pdoc = GetDocument();
	glDeleteTextures(10,pdoc->myTexs);

	/*high-resolution timer kan niet gebruikt worden. Zie nota aan top van file
	timeKillEvent(timerID);
    */
	KillTimer(1);
	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
}

void CGameView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	CGameDoc* pdoc = GetDocument();
	
// grootte van de clientdc ophalen
	GetClientRect(&myRect);
	size.cx= myRect.right-myRect.left;
	size.cy= myRect.bottom-myRect.top;

// OpenGL (her)-initialisatie	
	GLsizei width, height;
	GLdouble ratio;

	width = cx;
	height = cy;

	if (cy=0) ratio=(GLdouble)width;
	else ratio= (GLdouble)width / (GLdouble)height;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45, ratio, 1.0, 100.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDrawBuffer(GL_BACK);
	glEnable(GL_DEPTH_TEST);
	
	if(smooth)
		glShadeModel(GL_SMOOTH);
	else
		glShadeModel(GL_FLAT);

	if(pdoc->light) {
		glEnable(GL_LIGHTING);
		if(pdoc->textures)
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	}
	else {
		glDisable(GL_LIGHTING);
		if(pdoc->textures)
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	};

	if(pdoc->textures)
		glEnable( GL_TEXTURE_2D );
	else
		glDisable( GL_TEXTURE_2D );
}

void CGameView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//geweer wordt gevuurd
	SetCursor(NULL);	//AfxGetApp()->LoadCursor(IDC_NOCUR));
	CGameDoc* pDoc = GetDocument();
	
	pDoc->boom=true;
	//kogel wordt uitgespuwd.
	pDoc->bullet[0].shot=true;
	//kogelpositie en richtingvector opslaan. (voor animatie)
	pDoc->bullet[0].x=pDoc->refx;
	pDoc->bullet[0].y=pDoc->refy;
	pDoc->bullet[0].z=pDoc->refz;
	pDoc->bullet[0].angle=pDoc->turn;
//	CView::OnLButtonDown(nFlags, point);
}

void CGameView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	SetCursor(NULL);	//AfxGetApp()->LoadCursor(IDC_NOCUR));
	CGameDoc* pDoc = GetDocument();

//  up-down hoek veranderen
	mypos=point;
	mypos.y-=size.cy/2;
	pDoc->refy = (double)-3*mypos.y/(size.cy/2)+2.0f;

// links-recht hoek aanpassen.
	CSize dxdy = mxpos - point;
	mxpos = point;
	pDoc->turn -= (double)dxdy.cx/40;
	pDoc->refx=pDoc->eyex + (4*cos(pDoc->turn));
	pDoc->refz=pDoc->eyez + (4*sin(pDoc->turn));
	
//	CView::OnMouseMove(nFlags, point);
}

void CGameView::OnSmooth() 
{
	// TODO: Add your command handler code here
	if(smooth) {
		smooth=FALSE;
		glShadeModel(GL_FLAT);
	}
	else {
		smooth=TRUE;
		glShadeModel(GL_SMOOTH);
	}
	//OpenGL herinitialiseren met andere shading parameters.
}

void CGameView::OnUpdateSmooth(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(smooth)	
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CGameView::OnFilter() 
{
	// TODO: Add your command handler code here
	if(filter)
		filter=FALSE;
	else
		filter=TRUE;

	CGameDoc* pdoc = GetDocument();

	//texture-filter parameters veranderen
	if(filter) {
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[0]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[1]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[2]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[3]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[4]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[5]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[6]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[7]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[8]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[9]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}
	else {
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[0]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[1]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[2]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[3]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[4]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[5]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[6]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[7]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[8]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glBindTexture(GL_TEXTURE_2D, pdoc->myTexs[9]);   		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}
}

void CGameView::OnUpdateFilter(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(filter)	
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CGameView::OnUpdateLight(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CGameDoc* pdoc = GetDocument();
	if(pdoc->light)	
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CGameView::OnLight() 
{
	// TODO: Add your command handler code here
	CGameDoc* pdoc = GetDocument();
	if(pdoc->light) {
		pdoc->light=FALSE;
		glDisable(GL_LIGHTING);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	}
	else {
		pdoc->light=TRUE;
		glEnable(GL_LIGHTING);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	};
}

void CGameView::OnTextures() 
{
	// TODO: Add your command handler code here
	CGameDoc* pdoc = GetDocument();
	if(pdoc->textures) {
		pdoc->textures=FALSE;
		glDisable(GL_TEXTURE_2D);
	}
	else {
		pdoc->textures=TRUE;
		glEnable( GL_TEXTURE_2D );
	};
}

void CGameView::OnUpdateTextures(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	CGameDoc* pdoc = GetDocument();
	if(pdoc->textures)	
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}


BOOL CGameView::InObject(POINT *test)
{
	//test if player enters any of the objects in the world
	for(int i=0;i<nr_of_objects;i++) {
		switch(Objects[i].what) {
		case RECTANG : //3 punten nodig
			if ((test->x>Objects[i].points[0].x) && (test->x<Objects[i].points[1].x)
				&& (test->y>Objects[i].points[0].y) && (test->y<Objects[i].points[3].y))
				return true;
			break;
		case SQUARE : // 2 punten nodig
			//not implemented yet
			break;
		case CIRCLE : // alle 8 punten nodig om cirkel te benaderen
			//not implemented yet
			break;
		};
	};
	//if not then its not in any of the objects
	return false;

}


void CGameView::CheckKeys(CGameDoc* pDoc)
{
	int key_table[8];  
	POINT posxz;
  
         
	// Update the lookup table according to the current state of the 
	//   direction keys. For our purposes, the key is down if either
	//   the most-significant bit (key is down) or the least-significant 
	//   (key has been down since the last time we checked) is set. 
	key_table[INDEX_RIGHT]     = GetAsyncKeyState(VK_RIGHT);
	key_table[INDEX_DOWNRIGHT] = GetAsyncKeyState(VK_NEXT);
	key_table[INDEX_DOWN]      = GetAsyncKeyState(VK_DOWN);
	key_table[INDEX_DOWNLEFT]  = GetAsyncKeyState(VK_END);
	key_table[INDEX_LEFT]      = GetAsyncKeyState(VK_LEFT);
	key_table[INDEX_UPLEFT]    = GetAsyncKeyState(VK_HOME);
	key_table[INDEX_UP]        = GetAsyncKeyState(VK_UP);
	key_table[INDEX_UPRIGHT]   = GetAsyncKeyState(VK_PRIOR);
	
	BOOL bewogen=false;
	if (key_table[INDEX_UP]    
		|| key_table[INDEX_UPRIGHT]
		|| key_table[INDEX_UPLEFT]) { 
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn)/2);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn)/2);			
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn)/2;
				pDoc->eyez-=sin(pDoc->turn)/2;
			}
			else{
				pDoc->refx+=cos(pDoc->turn)/2;
				pDoc->refz+=sin(pDoc->turn)/2;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
			bewogen=true;
	};
	if (key_table[INDEX_DOWN]
		|| key_table[INDEX_DOWNLEFT]
		|| key_table[INDEX_DOWNRIGHT]) {
			posxz.x=(long)(pDoc->eyex-=cos(pDoc->turn)/2);
			posxz.y=(long)(pDoc->eyez-=sin(pDoc->turn)/2);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex+=cos(pDoc->turn)/2;
				pDoc->eyez+=sin(pDoc->turn)/2;
			}
			else{
				pDoc->refx-=cos(pDoc->turn)/2;
				pDoc->refz-=sin(pDoc->turn)/2;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
			bewogen=true;
	};

	if (key_table[INDEX_RIGHT]
		||key_table[INDEX_UPRIGHT]
		||key_table[INDEX_DOWNRIGHT]){ //zijstap rechts nemen (en niet draaien, dit wordt mbv muis gedaan)
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn+1.5707)/3);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn+1.5707)/3);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn+1.5707)/3;
				pDoc->eyez-=sin(pDoc->turn+1.5707)/3;
			}
			else{
				pDoc->refx+=cos(pDoc->turn+1.5707)/3;
				pDoc->refz+=sin(pDoc->turn+1.5707)/3;
			};
			if(!bewogen){
				pDoc->eyey=2-fabs(sin(looper))/8;
				looper+=0.4;
			};
	};

	if (key_table[INDEX_LEFT]
		||key_table[INDEX_UPLEFT]
		||key_table[INDEX_DOWNLEFT]){ //zijstap links nemen (en niet draaien, dit wordt mbv muis gedaan)
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn-1.5707)/3);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn-1.5707)/3);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn-1.5707)/3;
				pDoc->eyez-=sin(pDoc->turn-1.5707)/3;
			}
			else{
				pDoc->refx+=cos(pDoc->turn-1.5707)/3;
				pDoc->refz+=sin(pDoc->turn-1.5707)/3;
			};
			if(!bewogen){
				pDoc->eyey=2-fabs(sin(looper))/8;
				looper+=0.4;
			};
	};
}

void CGameView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CGameDoc *pdoc = GetDocument();

	if(pdoc->InGame)
	{
			//muis uit
		SetCursor(NULL);	//AfxGetApp()->LoadCursor(IDC_NOCUR));
	
			//bekijk toetsen via hardware
		CheckKeys(pdoc);
	
			//render een frame

		pdoc->RenderScene();
		SwapBuffers(dc.m_ps.hdc);
	}
}

void CGameView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CGameDoc *pdoc = GetDocument();

	if(pdoc->InGame)
	
	if(!hardware)
		Invalidate(false);
	else {
		CPaintDC dc(this);
		

		//muis uit
		SetCursor(NULL);	//AfxGetApp()->LoadCursor(IDC_NOCUR));
	
		//bekijk toetsen via hardware
		CheckKeys(pdoc);
	
		//render een frame
		pdoc->RenderScene();
		SwapBuffers(dc.m_ps.hdc);
	};	
}


////////////////////////////////////////////////////////////////////////////////
//Niet gebruikte functies

/*------------------------------------------------------------------------------
Dit was een test om de renderer in een aparte thread te steken.
Weeral kwamen veel restricties kijken bij het gebruik van MFC :(
Ik kon bvb geen variabele veranderen van CGameDoc (behorend tot de "main thread").
De pDoc->... etc wijst naar een CGameDoc-structuur in het lokale geheugen
van de "working-thread" (hieronder), ipv de CGameDoc waar de variabele staan
die de renderer gebruikt.
(dit werd uitgelegd in "Multithreading : programming tips" MSDN Library)

Een "thread" is een volledig op zichzelf werkend routine (of meerdere routines
) dat aan dezelfde snelheid als het hoofdprogramma (programma dat de thread aanmaakte) werkt.
Goede voorbeelden van threads zijn
- artificiele intelligentie bij spelletjes worden in achtergrond berekend
- achtergrond muziek 
- printopdracht in de achtergrond
--------------------------------------------------------------------------------
UINT MyThreadProc( LPVOID pParam )
{
    CGameView* pView = (CGameView*)pParam;
	CPaintDC dc((CGameView *)pParam);
	CGameDoc* pdoc = pView->GetDocument();
	static _int64 newtime, oldtime;
	_int64 LeftOver;
	int Updates;

	oldtime = timeGetTime();
	do {
		pView->CheckKeys(pdoc);
	    Updates = 0;
		newtime = timeGetTime();
		if (((newtime - oldtime) >= 50) // om de 50ms een frame (20 fps)
			  && (!pView->paused)){
			Updates = (int) ((newtime - oldtime) / 50);
			LeftOver = (newtime - oldtime) % 50;
			oldtime = newtime - LeftOver;
	    };
	if(Updates) {
		pdoc->RenderScene();
		SwapBuffers(dc.m_ps.hdc);
		dc.DrawIcon(pView->size.cx/2-16,pView->size.cy/2-16,AfxGetApp()->LoadIcon(IDI_AIM));
	};
	} while (1); //forever

    return 0;   // thread completed successfully
}
--------------------------------------------------------------------------------
Dit is de gewone keyboard opvanger. Vervangen door een hardware versie.
--------------------------------------------------------------------------------
void CGameView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	CGameDoc* pDoc = GetDocument();
	POINT posxz;

	if ((nChar==VK_UP)    
		|| (nChar==VK_PRIOR) 
		|| (nChar==VK_HOME)) { 
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn)/2);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn)/2);			
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn)/2;
				pDoc->eyez-=sin(pDoc->turn)/2;
			}
			else{
				pDoc->refx+=cos(pDoc->turn)/2;
				pDoc->refz+=sin(pDoc->turn)/2;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
	};
	if ((nChar==VK_DOWN)
		|| (nChar==VK_END)
		|| (nChar==VK_NEXT)){ 
			posxz.x=(long)(pDoc->eyex-=cos(pDoc->turn)/2);
			posxz.y=(long)(pDoc->eyez-=sin(pDoc->turn)/2);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex+=cos(pDoc->turn)/2;
				pDoc->eyez+=sin(pDoc->turn)/2;
			}
			else{
				pDoc->refx-=cos(pDoc->turn)/2;
				pDoc->refz-=sin(pDoc->turn)/2;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
	};

	if ((nChar==VK_RIGHT)
		||(nChar==VK_PRIOR)
		||(nChar==VK_NEXT)){ //zijstap rechts nemen (en niet draaien, dit wordt mbv muis gedaan)
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn+1.5707)/3);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn+1.5707)/3);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn+1.5707)/3;
				pDoc->eyez-=sin(pDoc->turn+1.5707)/3;
			}
			else{
				pDoc->refx+=cos(pDoc->turn+1.5707)/3;
				pDoc->refz+=sin(pDoc->turn+1.5707)/3;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
	};

	if ((nChar==VK_LEFT)
		||(nChar==VK_HOME)
		||(nChar==VK_END)){ //zijstap links nemen (en niet draaien, dit wordt mbv muis gedaan)
			posxz.x=(long)(pDoc->eyex+=cos(pDoc->turn-1.5707)/3);
			posxz.y=(long)(pDoc->eyez+=sin(pDoc->turn-1.5707)/3);
			if((pDoc->eyex > 18) || (pDoc->eyex<-18) || (pDoc->eyez > 38) || (pDoc->eyez < 2)
				|| InObject(&posxz)) {
				pDoc->eyex-=cos(pDoc->turn-1.5707)/3;
				pDoc->eyez-=sin(pDoc->turn-1.5707)/3;
			}
			else{
				pDoc->refx+=cos(pDoc->turn-1.5707)/3;
				pDoc->refz+=sin(pDoc->turn-1.5707)/3;
			};
			pDoc->eyey=2-fabs(sin(looper))/8;
			looper+=0.4;
	};

	Invalidate(FALSE); //false omdat OGL clearscreen doet.
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
--------------------------------------------------------------------------------
Deze functie had ik gemaakt om met een hoge resolutie timer een behoorlijke 
vloeiende framerate te behalen.
Dit crashte echter.
Na opzoeking in de MSDN library, ben ik tot de vaststelling gekomen dat dit een
gekende 'bug' is in MFC. Dus high-resolution timers kunnen niet worden gebruikt
met MFC applicaties...
--------------------------------------------------------------------------------
void CALLBACK TheLoop(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    CGameView *pview = (CGameView *) dwUser;
	CPaintDC dc((CGameView *)dwUser);
	CGameDoc* pdoc = pview->GetDocument();
	pview->CheckKeys();
	pdoc->RenderScene();
	SwapBuffers(dc.m_ps.hdc);
	dc.DrawIcon(pview->size.cx/2-16,pview->size.cy/2-16,AfxGetApp()->LoadIcon(IDI_AIM));
}

--------------------------------------------------------------------------------
Dit is de eerste OnPaint waarmee ik OGL aanriep en dan die geweer-bitmaps op het
scherm kopieerde. Daarna het visier erop zette.
--------------------------------------------------------------------------------
void CGameView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here


	// Let's do the OpenGL code first
	CGameDoc* pDoc = GetDocument();
	pDoc->RenderScene();
	if (SwapBuffers(dc.m_ps.hdc)==FALSE)
	{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("SwapBuffers returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return;
	};

	// Add the gun bitmap to screen
	CBitmap Gun;
	CBitmap Mask;
	if(boom){
		Gun.LoadBitmap(IDB_BOOM);
		Mask.LoadBitmap(IDB_MASK2);
		boom=FALSE;
	}
	else{
		Gun.LoadBitmap(IDB_GUN);
		Mask.LoadBitmap(IDB_MASK1);
	};
	BITMAP gun;
	BITMAP mask;
	Gun.GetObject(sizeof(BITMAP),&gun);
	Mask.GetObject(sizeof(BITMAP),&mask);
	CDC dcMem;
	dcMem.CreateCompatibleDC(&dc);

	dcMem.SelectObject(&Mask);
	//size en myRect zijn public variables en worden aangemaakt in OnSize
	int x=size.cx/2-size.cx/5;
	int y=size.cy-size.cy/3;
	int	w=2*size.cx/5;
	int h=size.cy/3;
	dc.StretchBlt(x,y,w,h,&dcMem,0,0,gun.bmWidth,gun.bmHeight,SRCAND);

	dcMem.SelectObject(&Gun);
	dc.StretchBlt(x,y,w,h,&dcMem,0,0,gun.bmWidth,gun.bmHeight,SRCPAINT);
	
	// Add some debug-info on screen
	char jan[50];
	sprintf(jan,"Eye-X = %f | Eye-Y = %f | Eye-Z = %f ",pDoc->eyex,pDoc->eyey,pDoc->eyez);
	dc.TextOut(0,0,jan);

	sprintf(jan,"RefX = %f | RefY = %f | RefZ = %f ",pDoc->refx,pDoc->refy,pDoc->refz);
	dc.TextOut(0,16,jan);
	sprintf(jan,"Turn-angle = %f | View-angle = %f ",turn,viewangle);
	dc.TextOut(0,32,jan);

	//draw aiming
	dc.DrawIcon(size.cx/2-16,size.cy/2-16,AfxGetApp()->LoadIcon(IDI_AIM));
	//put score in the statusbar
	CString score;
	score.Format("Player 1: 0  | Player 2: 0   ");
	// Do not call CView::OnPaint() for painting messages
}

*/


