// GameView.h : interface of the CGameView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEVIEW_H__01580F8C_A31C_11D3_B71A_080000346601__INCLUDED_)
#define AFX_GAMEVIEW_H__01580F8C_A31C_11D3_B71A_080000346601__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// indices into arrow key state table
#define INDEX_UPLEFT    0
#define INDEX_UP        1
#define INDEX_UPRIGHT   2
#define INDEX_RIGHT     3
#define INDEX_DOWNRIGHT 4
#define INDEX_DOWN      5
#define INDEX_DOWNLEFT  6
#define INDEX_LEFT      7

enum ObjectType {SQUARE, RECTANG, CIRCLE};

struct OBJECT {
	ObjectType what;
	POINT points[8];
};

class CGameView : public CView
{
protected: // create from serialization only
	HGLRC my_GLRendContext;
	int my_GLpixelindex;
	
	CGameView();
	DECLARE_DYNCREATE(CGameView)

// Attributes
public:
	CGameDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGameView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	bool hardware;
	void CheckKeys(CGameDoc* pDoc);
	double looper;
	BOOL InObject(POINT* test);
	int nr_of_objects;
	OBJECT Objects[20]; //Room for 20 objects, we will only use 2 (walls)
	int screenWidth;
	int screenHeight;
	BOOL filter;
	BOOL smooth;
	CSize size;
	CRect myRect;
	CPoint mypos, mxpos;
	double viewangle;
	virtual ~CGameView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	BOOL CreateGLRenderContext( HDC myDC);
	BOOL SetWindowPixelFormat( HDC myDC);
	//{{AFX_MSG(CGameView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSmooth();
	afx_msg void OnUpdateSmooth(CCmdUI* pCmdUI);
	afx_msg void OnFilter();
	afx_msg void OnUpdateFilter(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLight(CCmdUI* pCmdUI);
	afx_msg void OnLight();
	afx_msg void OnTextures();
	afx_msg void OnUpdateTextures(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in GameView.cpp
inline CGameDoc* CGameView::GetDocument()
   { return (CGameDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GAMEVIEW_H__01580F8C_A31C_11D3_B71A_080000346601__INCLUDED_)
